'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.installExternals = exports.writeExternals = undefined;


// EXTERNALS
//    check updated
//      => write paths to disk
//      => pack with webpack

let writeExternals = exports.writeExternals = function () {
  var ref = _asyncToGenerator(function* () {
    let opts = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    if (opts.force || _disk2.default.externalsPaths.hasChanged()) {
      const paths = yield _disk2.default.externalsPaths.read();

      yield _disk2.default.externalsIn.write(function (current, write) {
        write((0, _requireString2.default)(paths));
      });
    }
  });

  return function writeExternals(_x) {
    return ref.apply(this, arguments);
  };
}();

let installExternals = exports.installExternals = function () {
  var ref = _asyncToGenerator(function* (filePath) {
    if ((0, _opts2.default)('hasRunInitialBuild')) yield (0, _install.installAll)(_cache2.default.getExternals(filePath));
  });

  return function installExternals(_x3) {
    return ref.apply(this, arguments);
  };
}();

exports.runExternals = runExternals;

var _webpack = require('./lib/webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpackConfig = require('./lib/webpackConfig');

var _webpackConfig2 = _interopRequireDefault(_webpackConfig);

var _disk = require('../disk');

var _disk2 = _interopRequireDefault(_disk);

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _cache = require('../cache');

var _cache2 = _interopRequireDefault(_cache);

var _requireString = require('./lib/requireString');

var _requireString2 = _interopRequireDefault(_requireString);

var _install = require('./install');

var _messages = require('./lib/messages');

var _fns = require('../lib/fns');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function runExternals() {
  const config = (0, _webpackConfig2.default)('externals.js', {
    entry: (0, _opts2.default)('deps').externalsIn
  });

  return (0, _webpack2.default)('externals', config, _messages.onInstalled);
}
//# sourceMappingURL=externals.js.map