'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fns = require('../../lib/fns');

var _opts = require('../../opts');

var _opts2 = _interopRequireDefault(_opts);

var _disk = require('../../disk');

var _disk2 = _interopRequireDefault(_disk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

exports.default = function () {
  var ref = _asyncToGenerator(function* (reset) {
    (0, _fns.log)('bundler', 'remakeInstallDir');
    const deps = (0, _opts2.default)('deps');

    try {
      yield (0, _fns.mkdir)(deps.dir);

      if (reset) {
        yield Promise.all([(0, _fns.rm)(deps.externalsIn), (0, _fns.rm)(deps.externalsPaths), (0, _fns.rm)(deps.externalsOut), (0, _fns.rm)(deps.internalsIn), (0, _fns.rm)(deps.internalsOut)]);
      }

      yield Promise.all([(0, _fns.touch)(deps.externalsIn), (0, _fns.touch)(deps.externalsOut), (0, _fns.touch)(deps.internalsIn), (0, _fns.touch)(deps.internalsOut)]);
    }
    // disk.externalsPaths.write((_, write) => write([]))
    catch (e) {
      (0, _fns.handleError)(e);
    }
  });

  return function remakeInstallDir(_x) {
    return ref.apply(this, arguments);
  };
}();
//# sourceMappingURL=remakeInstallDir.js.map