'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = setMeta;

var _bridge = require('../../bridge');

var _bridge2 = _interopRequireDefault(_bridge);

var _cache = require('../../cache');

var _cache2 = _interopRequireDefault(_cache);

var _exec = require('../../lib/exec');

var _exec2 = _interopRequireDefault(_exec);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let meta = {}; // handles meta info on views passed from babel
// eventually given to atom for IDE

function setMeta(_ref) {
  let file = _ref.file;
  let views = _ref.views;

  _cache2.default.setFileMeta(file, views);
  _bridge2.default.broadcast('file:meta', { file, views });
  Object.keys(views).map(view => {
    meta[view] = views[view];
  });
}

// send messages for view adds and deletes
// cache.onAddView(view => bridge.message('view:add', { view, meta: meta[view] }))
// cache.onDeleteView(view => bridge.message('view:delete', { view, meta: meta[view] }))

_bridge2.default.onMessage('editor', _ref2 => {
  let type = _ref2.type;
  let key = _ref2.key;
  let el = _ref2.el;
  let view = _ref2.view;

  if (type.substr(0, 6) != 'focus:') return;

  if (view === undefined) return;
  // the browser turns One.Two into One-Two
  view = view.replace(/\-/, '.');

  if (!meta[view]) return;

  const data = meta[view].data;

  if (data) {
    const viewData = { name: view, file: data.file };

    if (type == 'focus:style') {
      _bridge2.default.broadcast('editor:style', {
        view: viewData,
        position: meta[view].styles[el]
      }, 'focus');
    }

    if (type == 'focus:element') {
      if (!view || !key) return;
      _bridge2.default.broadcast('editor:element', {
        view: viewData,
        position: meta[view].els[key]
      }, 'focus');
    }
  }

  //todo dont focus escape every time
  (0, _exec2.default)(`osascript -e 'activate application "Atom"'`);
});
//# sourceMappingURL=onMeta.js.map