'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = undefined;

let styles = exports.styles = function () {
  var ref = _asyncToGenerator(function* () {
    const where = {
      src: (0, _opts2.default)('styleDir'),
      glob: ['*', '**/*'],
      out: (0, _opts2.default)('styleOutDir')
    };

    yield (0, _fns.mkdir)(where.out);
    return gulpStyles(where);
  });

  return function styles() {
    return ref.apply(this, arguments);
  };
}();

// todo this is re-running every build --watch change, use $.watch


var _helpers = require('./lib/helpers');

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _fns = require('../lib/fns');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function gulpStyles(_ref) {
  let src = _ref.src;
  let glob = _ref.glob;
  let out = _ref.out;

  return new Promise((resolve, reject) => {
    _helpers.gulp.src(glob, { cwd: src }).pipe(_helpers.$.plumber()).pipe(_helpers.$.if((0, _opts2.default)('watch'), _helpers.$.multipipe(_helpers.$.cached('styles'), _helpers.$.remember('styles')))).pipe(_helpers.$.concat((0, _opts2.default)('styleOutName'))).pipe(_helpers.gulp.dest(out)).on('end', () => {
      _fns.log.gulp('finished styles');
      resolve();
    }).on('error', reject);

    // resolve right away for watch
    if ((0, _opts2.default)('watch')) resolve();
  });
}
//# sourceMappingURL=styles.js.map