'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

let deleteJS = function () {
  var ref = _asyncToGenerator(function* (view) {
    const file = (0, _fns.p)(OPTS.outDir, view + '.js');
    (0, _fns.log)('delete js', file);
    yield (0, _fns.rm)(file);
  });

  return function deleteJS(_x) {
    return ref.apply(this, arguments);
  };
}();

let deleteStyle = function () {
  var ref = _asyncToGenerator(function* (view) {
    const file = (0, _fns.p)((0, _opts2.default)('styleDir'), view + '.css');
    (0, _fns.log)('delete style', file);
    yield (0, _fns.rm)(file);
  });

  return function deleteStyle(_x2) {
    return ref.apply(this, arguments);
  };
}();

exports.default = watchDeletes;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _opts = require('../opts');

var _opts2 = _interopRequireDefault(_opts);

var _cache = require('../cache');

var _cache2 = _interopRequireDefault(_cache);

var _bridge = require('../bridge');

var _bridge2 = _interopRequireDefault(_bridge);

var _internals = require('../bundler/internals');

var _fns = require('./fns');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function watchDeletes() {
  try {
    _cache2.default.onDeleteView((() => {
      var ref = _asyncToGenerator(function* (view) {
        (0, _fns.log)('onDeleteView', view);
        yield deleteStyle(view);
        _bridge2.default.broadcast('stylesheet:remove', { view });
      }),
          _this = this;

      return function (_x3) {
        return ref.apply(_this, arguments);
      };
    })());

    _cache2.default.onDeleteFile((() => {
      var ref = _asyncToGenerator(function* (_ref) {
        let name = _ref.name;
        let file = _ref.file;
        let state = _ref.state;

        (0, _fns.log)('onDeleteFile', name, file, state);

        if (state.isInternal) yield (0, _internals.internals)();

        yield state.views.forEach((() => {
          var ref = _asyncToGenerator(function* (view) {
            yield deleteStyle(view);
            yield deleteJS(view);
          }),
              _this = this;

          return function (_x5) {
            return ref.apply(_this, arguments);
          };
        })());

        _bridge2.default.broadcast('file:delete', { name });
      }),
          _this = this;

      return function (_x4) {
        return ref.apply(_this, arguments);
      };
    })());
  } catch (e) {
    (0, _fns.handleError)(e);
  }
}
//# sourceMappingURL=watchDeletes.js.map