'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createPlugin;

var _state = require('./state');

var _helpers = require('./lib/helpers');

var _helpers2 = _interopRequireDefault(_helpers);

var _Program = require('./nodes/Program');

var _Program2 = _interopRequireDefault(_Program);

var _ExportDeclaration = require('./nodes/ExportDeclaration');

var _ExportDeclaration2 = _interopRequireDefault(_ExportDeclaration);

var _ImportDeclaration = require('./nodes/ImportDeclaration');

var _ImportDeclaration2 = _interopRequireDefault(_ImportDeclaration);

var _ViewStatement = require('./nodes/ViewStatement');

var _ViewStatement2 = _interopRequireDefault(_ViewStatement);

var _Statement = require('./nodes/Statement');

var _Statement2 = _interopRequireDefault(_Statement);

var _JSXElement = require('./nodes/JSXElement');

var _JSXElement2 = _interopRequireDefault(_JSXElement);

var _JSXAttribute = require('./nodes/JSXAttribute');

var _JSXAttribute2 = _interopRequireDefault(_JSXAttribute);

var _ArrowFunctionExpression = require('./nodes/ArrowFunctionExpression');

var _ArrowFunctionExpression2 = _interopRequireDefault(_ArrowFunctionExpression);

var _FunctionExpression = require('./nodes/FunctionExpression');

var _FunctionExpression2 = _interopRequireDefault(_FunctionExpression);

var _FunctionDeclaration = require('./nodes/FunctionDeclaration');

var _FunctionDeclaration2 = _interopRequireDefault(_FunctionDeclaration);

var _ReturnStatement = require('./nodes/ReturnStatement');

var _ReturnStatement2 = _interopRequireDefault(_ReturnStatement);

var _CallExpression = require('./nodes/CallExpression');

var _CallExpression2 = _interopRequireDefault(_CallExpression);

var _VariableDeclaration = require('./nodes/VariableDeclaration');

var _VariableDeclaration2 = _interopRequireDefault(_VariableDeclaration);

var _AssignmentExpression = require('./nodes/AssignmentExpression');

var _AssignmentExpression2 = _interopRequireDefault(_AssignmentExpression);

var _UpdateExpression = require('./nodes/UpdateExpression');

var _UpdateExpression2 = _interopRequireDefault(_UpdateExpression);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createPlugin(options) {
  // running without options
  if (options.Transformer) return MotionPlugin(options);

  // plugin
  function MotionPlugin(_ref) {
    let Plugin = _ref.Plugin;
    let t = _ref.types;


    // init
    (0, _state.init)();
    (0, _helpers2.default)(options, t);

    return new Plugin('motion-transform', {
      metadata: { group: 'builtin-trailing' },
      visitor: {
        Program: _Program2.default,
        ExportDeclaration: _ExportDeclaration2.default,
        ImportDeclaration: _ImportDeclaration2.default,
        ViewStatement: _ViewStatement2.default,
        Statement: _Statement2.default,
        JSXElement: _JSXElement2.default,
        JSXAttribute: _JSXAttribute2.default,
        ArrowFunctionExpression: _ArrowFunctionExpression2.default,
        FunctionExpression: _FunctionExpression2.default,
        FunctionDeclaration: _FunctionDeclaration2.default,
        ReturnStatement: _ReturnStatement2.default,
        CallExpression: _CallExpression2.default,
        VariableDeclaration: _VariableDeclaration2.default,
        AssignmentExpression: _AssignmentExpression2.default,
        UpdateExpression: _UpdateExpression2.default
      }
    });
  }

  return MotionPlugin;
}
//# sourceMappingURL=file.js.map